'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.createInitiallyLoadedGuard = createInitiallyLoadedGuard;

var _react = require('react');

var React = _interopRequireWildcard(_react);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO
function createInitiallyLoadedGuard(_ref) {
  var _class, _temp2;

  var LoaderComponent = _ref.LoaderComponent;
  /**
   * Shape of props for InitiallyLoadedGuardComponent.
   *
   * @memberof Guard/InitiallyLoadedGuard
   */


  /**
   * Shape of InitiallyLoadedGuardComponent's State.
   *
   * @property accessAllowed - Flag to know if should display guard's children or not.
   * @memberof Guard/InitiallyLoadedGuard
   */

  /**
   * Main class for InitiallyLoadedGuardComponent.
   *
   * @extends React.PureComponent
   * @memberof Guard/InitiallyLoadedGuard
   */
  return _temp2 = _class = function (_React$PureComponent) {
    _inherits(InitiallyLoadedGuardComponent, _React$PureComponent);

    function InitiallyLoadedGuardComponent() {
      var _ref2;

      var _temp, _this, _ret;

      _classCallCheck(this, InitiallyLoadedGuardComponent);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = InitiallyLoadedGuardComponent.__proto__ || Object.getPrototypeOf(InitiallyLoadedGuardComponent)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { accessAllowed: false, isFirstLoad: true, loadCalled: false }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(InitiallyLoadedGuardComponent, [{
      key: 'componentDidMount',


      /**
       * React's method that is called after the component output has been rendered to the DOM.
       *
       * Calls external check to know if user can access its children.
       *
       * @memberof Guard/InitiallyLoadedGuard.InitiallyLoadedGuardComponent#
       */
      value: function componentDidMount() {
        var _props = this.props,
            loadData = _props.loadData,
            loadingParams = _props.loadingParams;


        if (typeof loadingParams !== 'undefined') {
          loadData(loadingParams);
        } else {
          loadData();
        }
      }

      /**
       * React's method to render component.
       *
       * Render's children of InitiallyLoadedGuardComponent in case of allowed access.
       *
       * @returns {?React.Node} Guard's children or possible `null`.
       * @memberof Guard/InitiallyLoadedGuard.InitiallyLoadedGuardComponent#
       */

    }, {
      key: 'render',
      value: function render() {
        var accessAllowed = this.state.accessAllowed;


        if (!accessAllowed) return React.createElement(LoaderComponent);

        return React.createElement(React.Fragment, null, this.props.children);
      }
    }], [{
      key: 'getDerivedStateFromProps',


      /**
       * React's method to ge new state from props and old state.
       *
       * Sets #allowedAccess flag in state into `true` then loading changes from true into false.
       *
       * @param {InitiallyLoadedGuardComponentProps} props Current component's props.
       * @param {InitiallyLoadedGuardComponentState} state Old component's state.
       * @returns {InitiallyLoadedGuardComponentState} New comports's state.
       * @memberof Guard/InitiallyLoadedGuard.InitiallyLoadedGuardComponent
       */
      value: function getDerivedStateFromProps(props, state) {
        var loadCalled = state.loadCalled || props.loading;
        var isFirstLoad = state.isFirstLoad && (props.loading || !loadCalled);

        return {
          accessAllowed: loadCalled && (isFirstLoad ? !props.loading : true),
          isFirstLoad: isFirstLoad,
          loadCalled: loadCalled
        };
      }

      /**
       * Guard component's default state.
       * @memberof Guard/InitiallyLoadedGuard.InitiallyLoadedGuardComponent#
       */

    }]);

    return InitiallyLoadedGuardComponent;
  }(React.PureComponent), _class.defaultProps = {
    loadData: function () {}
  }, _temp2;
}